unit GGLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TGGLabel = class(TGraphicControl)
  private
    { Private 錾 }

    //F
    AColor:TColor;
    BCOlor:TColor;
    AFont  :TFont;
    ACaption:String;

    procedure SetAColor(Value:TCOlor);
    procedure SetBColor(Value:TCOlor);
    procedure SetFont(Value:TFont);
    procedure SetCaption(Value:String);


  protected
    { Protected 錾 }

    procedure Paint;override;
    procedure UpDate;override;

  public
    { Public 錾 }

    constructor Create(AOwner:TComponent);override;
    destructor  Destroy;override;
    procedure   StyleChanged(Sender: TObject);

  published
    { Published 錾 }

    property Font:TFOnt read AFont write SetFont;
    property BeforeColor:TColor read BColor write SetBColor;
    property AfterColor :TColor read AColor write SetAColor;
    property Caption :String read ACaption write SetCaption;
    property DragCursor;	 { hbOAhhbvvpeB }
    property DragMode;
    property OnDragDrop;	 { hbOAhhbvCxg }
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;	 { }EXCxg }
    property OnMouseMove;
    property OnMouseUp;



  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('buin2gou', [TGGLabel]);
end;

procedure TGGLabel.SetAColor(Value:TCOlor);
begin
  AColor:=Value;
  StyleChanged(Self);
end;

procedure TGGLabel.SetBColor(Value:TCOlor);
begin
  BColor:=Value;
  StyleChanged(Self);
end;

procedure TGGLabel.SetCaption(Value:String);
begin
 ACaption:=Value;
 StyleChanged(Self);
end;

procedure TGGLabel.SetFont(Value:TFont);
begin
  AFont.Assign(Value);
end;

constructor TGGLabel.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);

  AFont:=TFont.Create;
  AFont.OnChange:=StyleChanged;
  If Width=0 then Width:=100;
  If Height=0 then Height:=10;

end;

destructor  TGGLabel.Destroy;
begin

  AFont.Free;

  inherited Destroy;

end;

procedure TGGLabel.Paint;
var x,y,i,j:Integer;
    BMP    :TBitmap;
    pBit   :PByteArray;
    r,g,b,r2,g2,b2:Byte;
begin

  BMP:=TBitmap.Create;
  try
   //TCY̎w
   BMP.Width :=Width;
   BMP.Height:=Height;
   BMP.PixelFormat:=pf24Bit;

   r :=GetBValue(AColor);
   g :=GetGValue(AColor);
   b :=GetRValue(AColor);
   r2:=GetBValue(BColor);
   g2:=GetGValue(BColor);
   b2:=GetRValue(BColor);

   for y:=0 to Height-1 do begin
       pBit:=BMP.ScanLine[y];
       i:=0;
       for x:=0 to Width-1 do begin
           j:=Width-x;
           pBit[i]:=((r*x+r2*j) div Width);
           inc(i);
           pBit[i]:=((g*x+g2*j) div Width);
           inc(i);
           pBit[i]:=((b*x+b2*j) div Width);
           inc(i);
       end;
   end;

   BMP.Canvas.Font.Assign(AFont);
   BMP.Canvas.Brush.Style:=bsClear;
   BMP.Canvas.TextOut(0,0,ACaption);


   //]
   Bitblt(Canvas.Handle,0,0,Width,Height,BMP.Canvas.Handle,0,0,SRCCOPY);

  finally
   BMP.Free;
  end;
end;

procedure TGGLabel.UpDate;
begin
  Paint;
end;

procedure TGGLabel.StyleChanged(Sender: TObject);
begin
    Invalidate();								{R|[lgčĕ` }
end;

end.
